searchData={"items":[{"type":"module","title":"Livebook","doc":"This module provides a public Elixir API for integrating with Livebook.","ref":"Livebook.html"},{"type":"module","title":"Configuration - Livebook","doc":"See `config_runtime/0` for bootstrapping the default runtime\nconfiguration. There are several public configuration entries that\nyou can customize.","ref":"Livebook.html#module-configuration"},{"type":"module","title":"Custom plugs - Livebook","doc":"You can list a number of plugs to call directly before the Livebook\nrouter\n\n    config :livebook, :plugs, [{CustomPlug, []}]","ref":"Livebook.html#module-custom-plugs"},{"type":"module","title":"Embedded runtime dependencies - Livebook","doc":"In case you use the Embedded runtime and support installing\ndependencies with `Mix.install/2`, you can make those discoverable\nin the package search, by configuring a loader function:\n\n    config :livebook, Livebook.Runtime.Embedded,\n      load_packages: {Loader, :packages, []}\n\nThe function should return a list of entries like this:\n\n    [\n      %{\n        dependency: %{dep: {:kino, \"~> 0.6.1\"}, config: []},\n        description: \"Interactive widgets for Livebook\",\n        name: \"kino\",\n        url: \"https://hex.pm/packages/kino\",\n        version: \"0.6.1\"\n      }\n    ]","ref":"Livebook.html#module-embedded-runtime-dependencies"},{"type":"module","title":"Custom learn notebooks - Livebook","doc":"**Note that this is compile time configuration.**\n\nA list of additional notebooks to include in the Learn section.\n\nNote that the notebooks are loaded and embedded in a compiled module,\nso the paths are accessed at compile time only.\n\n    config :livebook, :learn_notebooks, [\n      %{\n        # Required notebook path\n        path: \"/path/to/notebook.livemd\",\n        # Optional notebook identifier for URLs, as in /learn/notebooks/{slug}\n        # By default the slug is inferred from file name, so there is no need to set it\n        slug: \"my-notebook\"\n        # Optional list of images\n        image_paths: [\n          # This image can be sourced as images/myimage.jpg in the notebook\n          \"/path/to/myimage.jpg\"\n        ],\n        # Optional details for the notebook card. If omitted, the notebook\n        # is hidden in the UI, but still accessible under /learn/notebooks/{slug}\n        details: %{\n          cover_path: \"/path/to/logo.png\",\n          description: \"My custom notebook that showcases some amazing stuff.\"\n        }\n      },\n      %{\n        path: \"/path/to/other_notebook.livemd\"\n      }\n    ]","ref":"Livebook.html#module-custom-learn-notebooks"},{"type":"function","title":"Livebook.config_runtime/0","doc":"Executes Livebook's `config/runtime.exs`.\n\nIf you use Livebook as a dependency, you can add the following\nto your `config/runtime.exs` to trigger Livebook's `config/runtime.exs`\nconfiguration:\n\n    Livebook.config_runtime()","ref":"Livebook.html#config_runtime/0"},{"type":"function","title":"Livebook.live_markdown_to_elixir/1","doc":"Parses the given Live Markdown document and converts it to Elixir\nsource code.","ref":"Livebook.html#live_markdown_to_elixir/1"},{"type":"function","title":"Limitations - Livebook.live_markdown_to_elixir/1","doc":"Note that the resulting script may not compile in some cases, for\nexample if you define a macro in one cell and import it in another\ncell, it works fine in Livebook, because each cell is compiled\nseparately. However, when running the script it gets compiled as a\nwhole and consequently doing so doesn't work.\n\nAdditionally, branching sections are commented out.","ref":"Livebook.html#live_markdown_to_elixir/1-limitations"},{"type":"extras","title":"Welcome to Livebook","doc":"# Livebook\n\n[![Website](https://img.shields.io/badge/-Website-%23ff87a7)](https://livebook.dev/)\n[![Latest Version](https://img.shields.io/hexpm/v/livebook?color=b5a3be&label=Latest+version)](https://hexdocs.pm/livebook)\n\nLivebook is a web application for writing interactive and collaborative code notebooks. It features:\n\n  * Code notebooks with Markdown support and Code cells where Elixir code is evaluated on demand.\n\n  * Rich code editor through [CodeMirror](https://codemirror.net/): with support for autocompletion, inline documentation, code formatting, etc.\n\n  * Interactive results via [Kino](https://github.com/elixir-nx/kino): display [Vega-Lite charts](https://vega.github.io/vega-lite/), tables, maps, and more.\n\n  * Automation: use Smart cells to perform high-level tasks and write notebooks faster than ever. Query databases, plot charts, build maps, and more directly from Livebook's UI.\n\n  * Reproducible: Livebook ensures your code runs in a predictable order, all the way down to package management. It also tracks your notebook state, annotating which parts are stale.\n\n  * Collaboration: multiple users can work on the same notebook at once, no additional setup required.\n\n  * Decentralized: Livebook is open-source and you can run it anywhere. The [\"Run in Livebook\" badge](https://livebook.dev/badge) makes it easy to import any Livebook into your own Livebook.\n\n  * Versionable: notebooks are stored in the `.livemd` format, which is a subset of Markdown with support for diagrams via [Mermaid](https://mermaid-js.github.io/mermaid) and for mathematical formulas via [KaTex](https://katex.org/). `.livemd` files can be shared and play well with version control.\n\n  * Custom runtimes: when executing Elixir code, you can either start a fresh Elixir instance, connect to an existing node, or run it inside an existing Elixir project, with access to all of its modules and dependencies. This means Livebook can be a great tool to introspect and document existing projects too.","ref":"readme.html"},{"type":"extras","title":"Getting started - Welcome to Livebook","doc":"Head out to [the Install section](https://livebook.dev/#install) of Livebook's website to get started. Once Livebook is up and running on your machine, **visit the \"Learn\" section** with introductory guides and documentation on several Livebook features. Here is a sneak peak of the \"Welcome to Livebook\" guide:\n\n![Screenshot](https://github.com/livebook-dev/livebook/raw/main/.github/imgs/welcome.png)\n\nFor screencasts and news, check out [news.livebook.dev](https://news.livebook.dev/).","ref":"readme.html#getting-started"},{"type":"extras","title":"Installation - Welcome to Livebook","doc":"We provide several methods for running Livebook,\npick the one that best fits your use case.","ref":"readme.html#installation"},{"type":"extras","title":"Desktop app - Welcome to Livebook","doc":"* [Download the installer for Mac and Windows from our homepage](https://livebook.dev/#install)\n\n  * Latest stable builds: [Mac (Universal)](https://livebook.dev/releases/latest/LivebookInstall-latest-macos-universal.dmg),\n    [Windows](https://livebook.dev/releases/latest/LivebookInstall-latest-windows-x86_64.exe)\n\n  * Nightly builds: [Mac (Universal)](https://livebook.dev/releases/nightly/LivebookInstall-nightly-macos-universal.dmg),\n    [Windows](https://livebook.dev/releases/nightly/LivebookInstall-nightly-windows-x86_64.exe)\n\n  * Builds for particular Livebook version are available on our\n    [GitHub releases](https://github.com/livebook-dev/livebook/releases).","ref":"readme.html#desktop-app"},{"type":"extras","title":"Docker - Welcome to Livebook","doc":"Running Livebook using Docker is another great option to run Livebook\nin case you don't have Elixir installed.\n\n```shell\n# Running with the default configuration\ndocker run -p 8080:8080 -p 8081:8081 --pull always ghcr.io/livebook-dev/livebook\n\n# In order to access and save notebooks directly to your machine\n# you can mount a local directory into the container.\n# Make sure to specify the user with \"-u $(id -u):$(id -g)\"\n# so that the created files have proper permissions\ndocker run -p 8080:8080 -p 8081:8081 --pull always -u $(id -u):$(id -g) -v $(pwd):/data ghcr.io/livebook-dev/livebook\n\n# You can configure Livebook using environment variables,\n# for all options see the dedicated \"Environment variables\" section below\ndocker run -p 8080:8080 -p 8081:8081 --pull always -e LIVEBOOK_PASSWORD=\"securesecret\" ghcr.io/livebook-dev/livebook\n\n# Or if you need to run on different ports:\ndocker run -p 8090:8090 -p 8091:8091 --pull always -e LIVEBOOK_PORT=8090 -e LIVEBOOK_IFRAME_PORT=8091 ghcr.io/livebook-dev/livebook\n```\n\nTo deploy Livebook on your cloud platform, see our [Docker Deployment](docs/deployment/docker.md) guide.\n\nFor CUDA support, [see images with the \"cuda\" tag](https://github.com/livebook-dev/livebook/pkgs/container/livebook).\n\nTo try out features from the main branch you can alternatively\nuse the `ghcr.io/livebook-dev/livebook:edge` image.\nSee [Livebook images](https://github.com/livebook-dev/livebook/pkgs/container/livebook).","ref":"readme.html#docker"},{"type":"extras","title":"Embedded devices - Welcome to Livebook","doc":"If you want to run Livebook on embedded devices, such as Raspberry Pi, BeagleBone, etc.,\ncheck out [the Livebook firmware](https://github.com/nerves-livebook/nerves_livebook) built\nwith [Nerves](https://www.nerves-project.org/).","ref":"readme.html#embedded-devices"},{"type":"extras","title":"Direct installation with Elixir - Welcome to Livebook","doc":"You can run Livebook on your own machine using just Elixir. You will need\n[Elixir v1.16](https://elixir-lang.org/install.html) or later.\nLivebook also requires the following Erlang applications: `inets`,\n`os_mon`, `runtime_tools`, `ssl` and `xmerl`. Those applications come\nwith most Erlang distributions but certain package managers may split\nthem apart. For example, on Ubuntu, these Erlang applications can\nbe installed as follows:\n\n```shell\nsudo apt install erlang-inets erlang-os-mon erlang-runtime-tools erlang-ssl erlang-xmerl erlang-dev erlang-parsetools\n```\n\n**Note:** The [`livebook` package](https://hex.pm/packages/livebook)\nis meant to be used as a CLI tool. Livebook is not officially\nsupported as a Mix/Hex dependency.\n\n#### Escript\n\nRunning Livebook using Escript makes for a very convenient option\nfor local usage and provides easy configuration via CLI options.\n\n```shell\nmix do local.rebar --force, local.hex --force\nmix escript.install hex livebook\n\n# Start the Livebook server\nlivebook server\n\n# See all the configuration options\nlivebook server --help\n```\n\nAfter you install the escript, make sure you add the directory where\nElixir keeps escripts to your [$PATH](https://en.wikipedia.org/wiki/PATH_(variable)).\nIf you installed Elixir with `asdf`, you'll need to run `asdf reshim elixir`\nonce the escript is built.\n\nTo try out features from the main branch you can alternatively\ninstall the escript directly from GitHub like this:\n\n```shell\nmix escript.install github livebook-dev/livebook\n```\n\n#### From source\n\nYou can run latest Livebook directly from source.\n\n```shell\ngit clone https://github.com/livebook-dev/livebook.git\ncd livebook\nmix deps.get --only prod\n\n# Run the Livebook server\nMIX_ENV=prod mix phx.server\n```","ref":"readme.html#direct-installation-with-elixir"},{"type":"extras","title":"Security considerations - Welcome to Livebook","doc":"Livebook is built to document and execute code. Anyone with access to a Livebook instance\nwill be able to access any file and execute any code in the machine Livebook is running.\n\nFor this reason, Livebook only binds to the 127.0.0.1, allowing access to happen only within\nthe current machine. When running Livebook in the production environment - the recommended\nenvironment - we also generate a token on initialization and we only allow access to the\nLivebook if said token is supplied as part of the URL.","ref":"readme.html#security-considerations"},{"type":"extras","title":"Environment variables - Welcome to Livebook","doc":"<!-- Environment variables -->\n\nThe following environment variables can be used to configure Livebook on boot:\n\n  * `LIVEBOOK_ALLOW_URI_SCHEMES` - sets additional allowed hyperlink schemes to the\n    Markdown content. Livebook sanitizes links in Markdown, allowing only a few\n    standard schemes by default (such as http and https). Set it to a comma-separated\n    list of schemes.\n\n  * `LIVEBOOK_APP_SERVICE_NAME` - sets the application name used by the cloud\n    provider to aid debugging.\n\n  * `LIVEBOOK_APP_SERVICE_URL` - sets the application url to manage this\n    Livebook instance within the cloud provider platform.\n\n  * `LIVEBOOK_APPS_PATH` - the directory with app notebooks. When set, the apps\n    are deployed on Livebook startup with the persisted settings. Password-protected\n    notebooks will receive a random password, unless `LIVEBOOK_APPS_PATH_PASSWORD`\n    is set. When deploying using Livebook's Docker image, consider using\n    `LIVEBOOK_APPS_PATH_WARMUP`.\n\n  * `LIVEBOOK_APPS_PATH_HUB_ID` - deploy only the notebooks in\n    `LIVEBOOK_APPS_PATH` that belong to the given Hub ID\n\n  * `LIVEBOOK_APPS_PATH_PASSWORD` - the password to use for all protected apps\n    deployed from `LIVEBOOK_APPS_PATH`.\n\n  * `LIVEBOOK_APPS_PATH_WARMUP` - sets the warmup mode for apps deployed from\n    `LIVEBOOK_APPS_PATH`. Must be either \"auto\" (apps are warmed up on Livebook\n    startup, right before app deployment) or \"manual\" (apps are warmed up when\n    building the Docker image; to do so add \"RUN /app/bin/warmup_apps\" to\n    your image). Defaults to \"auto\".\n\n  * `LIVEBOOK_AWS_CREDENTIALS` - enable Livebook to read AWS Credentials from\n    environment variables, AWS Credentials, EC2/ECS metadata when configuring\n    S3 buckets.\n\n  * `LIVEBOOK_BASE_URL_PATH` - sets the base url path the web application is\n    served on. Useful when deploying behind a reverse proxy.\n\n  * `LIVEBOOK_CACERTFILE` - path to a local file containing CA certificates.\n    Those certificates are used during for server authentication when Livebook\n    accesses files from external sources.\n\n  * `LIVEBOOK_CLUSTER` - configures clustering strategy when running multiple\n    instances of Livebook using either the Docker image or an Elixir release.\n    See the \"Clustering\" section of our Docker Deployment guide for more\n    information: https://hexdocs.pm/livebook/docker.html\n\n  * `LIVEBOOK_COOKIE` - sets the cookie for running Livebook in a cluster.\n    Defaults to a random string that is generated on boot.\n\n  * `LIVEBOOK_DATA_PATH` - the directory to store Livebook's internal\n    configuration. Defaults to \"livebook\" under the default user data\n    directory.\n\n  * `LIVEBOOK_DEBUG` - enables verbose logging, when set to \"true\". Disabled\n    by default.\n\n  * `LIVEBOOK_DEFAULT_RUNTIME` - sets the runtime type that is used by default\n    when none is started explicitly for the given notebook. Must be either\n    \"standalone\" (Elixir standalone), \"attached:NODE:COOKIE\" (Attached node)\n    or \"embedded\" (Embedded). Defaults to \"standalone\".\n\n  * `LIVEBOOK_EPMDLESS` - if set to \"true\", it disables the usage of EPMD. This is\n    only supported within releases and defaults to true for the Desktop app.\n\n  * `LIVEBOOK_FIPS` - if set to \"true\", it enables the FIPS mode on startup.\n    See more details in [the documentation](https://hexdocs.pm/livebook/fips.html).\n\n  * `LIVEBOOK_FORCE_SSL_HOST` - sets a host to redirect to if the request is not over HTTPS.\n    Note it does not apply when accessing Livebook via localhost. Defaults to nil.\n\n  * `LIVEBOOK_HOME` - sets the home path for the Livebook instance. This is the\n    default path used on file selection screens and others. Defaults to the\n    user's operating system home.\n\n  * `LIVEBOOK_IDENTITY_PROVIDER` - controls whether Zero Trust Authentication\n    must be used as the identity provider. This is useful when deploying\n    Livebook inside a cloud platform, such as Cloudflare and Google.\n    Supported values are:\n\n      * `basic_auth: : `\n      * `cloudflare: `\n      * `google_iap: `\n      * `tailscale: `\n      * `custom:YourElixirModule`\n\n    See our authentication docs for more information: https://hexdocs.pm/livebook/authentication.html\n\n  * `LIVEBOOK_IFRAME_PORT` - sets the port that Livebook serves iframes at.\n    This is relevant only when running Livebook without TLS. Defaults to 8081.\n\n  * `LIVEBOOK_IFRAME_URL` - sets the URL that Livebook loads iframes from.\n    By default iframes are loaded from local `LIVEBOOK_IFRAME_PORT` when accessing\n    Livebook over http:// and from https://livebookusercontent.com when accessing over https://.\n\n  * `LIVEBOOK_IP` - sets the ip address to start the web application on.\n    Must be a valid IPv4 or IPv6 address.\n\n  * `LIVEBOOK_NODE` - sets the node name for running Livebook in a cluster.\n    Note that Livebook always runs using long names distribution, so the\n    node host name must use a fully qualified domain name (FQDN) or an IP\n    address.\n\n  * `LIVEBOOK_PASSWORD` - sets a password that must be used to access Livebook.\n    Must be at least 12 characters. Defaults to token authentication.\n\n  * `LIVEBOOK_PROXY_HEADERS` - a comma-separated list of headers that are set by\n    proxies. For example, `x-forwarded-for,x-forwarded-proto`. Configuring those\n    may be required when running Livebook behind reverse proxies.\n\n  * `LIVEBOOK_PORT` - sets the port Livebook runs on. If you want to run multiple\n    instances on the same domain with the same credentials but on different ports,\n    you also need to set `LIVEBOOK_SECRET_KEY_BASE`. Defaults to 8080. If set to 0,\n    a random port will be picked.\n\n  * `LIVEBOOK_SECRET_KEY_BASE` - sets a secret key that is used to sign and encrypt\n    the session and other payloads used by Livebook. Must be at least 64 characters\n    long and it can be generated by commands such as: `openssl rand -base64 48`.\n    Defaults to a random secret on every boot.\n\n  * `LIVEBOOK_SHUTDOWN_ENABLED` - controls if a shutdown button should be shown\n    in the homepage. Set it to \"true\" to enable it.\n\n  * `LIVEBOOK_TOKEN_ENABLED` - controls whether token authentication is enabled.\n    Enabled by default unless `LIVEBOOK_PASSWORD` is set. Set it to \"false\" to\n    disable it.\n\n  * `LIVEBOOK_UPDATE_INSTRUCTIONS_URL` - sets the URL to direct the user to for\n    updating Livebook when a new version becomes available.\n\n  * `LIVEBOOK_WITHIN_IFRAME` - controls if the application is running inside an\n    iframe. Set it to \"true\" to enable it. If you do enable it, then the application\n    must run with HTTPS.\n\nThe environment variables `ERL_AFLAGS` and `ERL_ZFLAGS` can also be set to configure\nLivebook and the notebook runtimes. `ELIXIR_ERL_OPTIONS` are also available to customize\nLivebook, but it is not forwarded to runtimes.\n\n<!-- Environment variables -->\n\nIf running Livebook via the command line, run `livebook server --help` to see\nall CLI-specific options.","ref":"readme.html#environment-variables"},{"type":"extras","title":"Livebook Desktop - Welcome to Livebook","doc":"When running Livebook Desktop, Livebook will invoke on boot a file named\n`~/.livebookdesktop.sh` on macOS or `%USERPROFILE%\\.livebookdesktop.bat`\non Windows. This file can set environment variables used by Livebook,\nsuch as:\n\n  * [the `PATH` environment variable](https://en.wikipedia.org/wiki/PATH_(variable))\n\n  * or to configure the Erlang VM, for instance, by setting\n    `ERL_AFLAGS=\"-proto_dist inet6_tcp\"` if you need Livebook to run over IPv6\n\nBe careful when modifying boot files, Livebook may be unable to start if\nconfigured incorrectly.","ref":"readme.html#livebook-desktop"},{"type":"extras","title":"Development - Welcome to Livebook","doc":"Livebook is primarily a Phoenix web application and can be setup as such:\n\n```shell\ngit clone https://github.com/livebook-dev/livebook.git\ncd livebook\nmix setup\n\n# Run the Livebook server\nmix phx.server\n\n# Run tests\nmix test\n```","ref":"readme.html#development"},{"type":"extras","title":"Acknowledgements - Welcome to Livebook","doc":"Thank you to [Uffizzi](https://www.uffizzi.com) for providing ephemeral environments to preview pull requests.","ref":"readme.html#acknowledgements"},{"type":"extras","title":"Desktop app builds - Welcome to Livebook","doc":"For macOS, run:\n\n```shell\n# Test macOS app locally\n(cd rel/app/macos && ./run.sh)\n\n# Build macOS installer\n.github/scripts/app/build_macos.sh\n```\n\nFor Windows, run:\n\n```shell\n# Test Windows app locally\n(cd rel/app/windows && ./run.sh)\n\n# Build Windows installer\n.github/scripts/app/build_windows.sh\n```","ref":"readme.html#desktop-app-builds"},{"type":"extras","title":"Platinum sponsors - Welcome to Livebook","doc":"Fly is a platform for running full stack apps and databases close to your users.","ref":"readme.html#platinum-sponsors"},{"type":"extras","title":"Sponsors - Welcome to Livebook","doc":"The platform where the machine learning community \ncollaborates on models, datasets, and applications.\n\n \n\n \n   \n     \n     \n     \n   \n \n\nTigris is a globally distributed S3-compatible object storage \nservice that provides low latency anywhere in the world.","ref":"readme.html#sponsors"},{"type":"extras","title":"License - Welcome to Livebook","doc":"Copyright (C) 2021 Dashbit\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0)\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#license"},{"type":"extras","title":"Use cases","doc":"# Use cases\n\nThere are many ways Elixir developers use and leverage Livebook today.","ref":"use_cases.html"},{"type":"extras","title":"Documentation with `Mix.install` - Use cases","doc":"Livebook is an excellent tool for documentation. Many Elixir packages use\nLivebook as tutorials but you can also directly run Livebook within the context\nof your existing application with the help of `Mix.install/2`.\n\nAs an example, imagine you have created a notebook inside your current project,\nat `notebooks/example.livemd`. In order to run within the root Mix project, using\nthe same configuration and dependencies versions, you can change your notebook\nsetup cell to invoke `Mix.install/2` with the following arguments:\n\n```elixir\nMix.install(\n  [\n    {:my_app, path: Path.join(__DIR__, \"..\"), env: :dev}\n  ],\n  config_path: :my_app,\n  lockfile: :my_app\n)\n```","ref":"use_cases.html#documentation-with-mix-install"},{"type":"extras","title":"Deploying custom apps and internal tooling - Use cases","doc":"Your Livebook notebooks can be deployed as applications which\nyou may then share within your team and company. Docker deployment\nis provided out of the box and you can automate your deployment,\nshare secrets, configure authentication and more with\n[Livebook Teams](https://livebook.dev/teams).","ref":"use_cases.html#deploying-custom-apps-and-internal-tooling"},{"type":"extras","title":"Communication and automation of Elixir systems - Use cases","doc":"You may also deploy notebooks as applications that automate and monitor\nlive Elixir systems. By clicking on \"+ Smart cell\", you will find Livebook\nprovides a \"Remote execution\" widget, that allows you to configure the\nnode name, cookie, and the code you want to execute on the remote node.\n\nThe node and cookie information are configured directly in the production\nsystem you want to connect to. For example, to connect to a\n[Phoenix application](https://phoenixframework.org/) running on your machine,\nyou may start it as follows:\n\n```shell\n$ iex --name phoenix-app@127.0.0.1 --cookie secret -S mix phx.server\n```\n\nWith this information in hand, you can query and automate tasks within\nexisting Elixir systems. You may also mix remote execution with Livebook's\nrich features to deploy applications that interact with those systems.","ref":"use_cases.html#communication-and-automation-of-elixir-systems"},{"type":"extras","title":"Debugging live systems (with attached mode) - Use cases","doc":"Livebook uses the concept of a **runtime**, which in practice is an Elixir node\nresponsible for evaluating your code. You can choose the runtime by clicking\nthe \"Runtime\" icon on the sidebar (or by using the `s` `r` keyboard shortcut).\n\nBy default, a new Elixir runtime is started (similarly to starting `iex`)\nfor each notebook. You can click reconnect whenever you want to discard the\ncurrent runtime and start a new one.\n\nYou can also manually *attach* to an existing node by picking the \"Attached Node\"\nruntime. While in the previous section we used the \"Remote execution\" smart cell\nto connect the default Livebook runtime to an existing node, the \"Attached Node\"\nwill make it so the Livebook runtime itself runs within the external node.\n\nTo do so, open up a new notebook and click the \"Runtime\" icon on the sidebar.\nClick to \"Configure\" the runtime and choose \"Attached node\". Input the\nname and cookie from the remote node and you should be ready to connect\nto it. Once connected, be careful: any code that you execute in the notebook\nnow runs within the connected application. You are also limited on actions\nyou may perform. For example, you can't install dependencies (nor would that\nbe a good idea on a running system).\n\nYou may also [connect your local Livebook instance to a node running in\nproduction depending on your platform](https://fly.io/docs/elixir/advanced-guides/connect-livebook-to-your-app/).","ref":"use_cases.html#debugging-live-systems-with-attached-mode"},{"type":"extras","title":"Scaffolding embedded systems with Nerves - Use cases","doc":"If you want to run Livebook on embedded devices, such as Raspberry Pi,\nBeagleBone, etc., check out [the Livebook\nfirmware](https://github.com/nerves-livebook/nerves_livebook) built\nwith [Nerves](https://www.nerves-project.org/). In such cases, Livebook\nuses a special runtime, called the Embedded Runtime, where all of your\ncode runs within Livebook itself, without starting additional runtimes\n(which may be too expensive on limited devices).","ref":"use_cases.html#scaffolding-embedded-systems-with-nerves"},{"type":"extras","title":"Ready to get started? - Use cases","doc":"Head out to [Livebook homepage](https://livebook.dev/) to install it.\nOnce you have it up and running, head to the \"Learn\" section on the\nsidebar to learn more!","ref":"use_cases.html#ready-to-get-started"},{"type":"extras","title":"Authentication","doc":"# Authentication\n\nLivebook has three levels of authentication:\n\n  * Instance authentication: this authenticates the user on all routes of your Livebook instance, including deployed notebooks and the admin section. This is done via Zero Trust Authentication and typically used when deploying Livebook to production. See the \"Authentication\" section on the sidebar for more information.\n\n  * Admin authentication: this authenticates access to Livebook admin interface, where users can create, write, and manage notebooks. Both password and token authentication are available. See the next section for more information.\n\n  * Deployed notebook authentication: additionally, when deploying notebooks as applications, each application may be password protected with a unique password. Only users authenticated as admin or with the password will be able to access them.","ref":"authentication.html"},{"type":"extras","title":"Admin authentication - Authentication","doc":"Livebook's default admin authentication method is token authentication. A token is automatically generated at startup and printed to the logs.\n\nYou may optionally enable password-based authentication by setting the environment variable `LIVEBOOK_PASSWORD` on startup or deployment. It must be at least 12 characters.\n\nTo disable authentication altogether, you may set the environment variable `LIVEBOOK_TOKEN_ENABLED` to `false`.","ref":"authentication.html#admin-authentication"},{"type":"extras","title":"Intro to Livebook Teams","doc":"# Intro to Livebook Teams\n\n[Livebook Teams](https://livebook.dev/teams/?ref=docs) is a product that amplifies Livebook with features designed for teams and businesses.\n\nIt's currently in free beta. You can [join the beta waiting list here](https://livebook.dev/teams/?ref=docs) to get early access.","ref":"intro_to_teams.html"},{"type":"extras","title":"Current features in the beta - Intro to Livebook Teams","doc":"- [Shared secrets management](shared_secrets.md)\n- [Shared file storages](shared_file_storages.md)\n- [Airgapped notebook deployment with Zero Trust Authentication](../deployment/docker.md#deploy-notebooks-as-applications)","ref":"intro_to_teams.html#current-features-in-the-beta"},{"type":"extras","title":"Shared secrets management","doc":"# Shared secrets management","ref":"shared_secrets.html"},{"type":"extras","title":"Overview - Shared secrets management","doc":"This feature allows your team to share Livebook secrets among team members in an easy way.\n\nJust add a secret to your organization hub, and Livebook Teams will synchronize it with the Livebook of every member of your organization.\n\n![](images/add_shared_secret.png)\n\nYou can also create such secrets directly from a notebook.\n\n![](images/add_shared_secret_from_notebook.png)\n\nShared secrets updates and deletions will also be synchronized.","ref":"shared_secrets.html#overview"},{"type":"extras","title":"How it works - Shared secrets management","doc":"Here's a video showing how that feature works.","ref":"shared_secrets.html#how-it-works"},{"type":"extras","title":"Security strengths - Shared secrets management","doc":"Livebook Teams cannot access the plain text version of your organization's secrets.\n\nLivebook encrypts your secrets locally in your machine using your Teams key. Then, the secret is sent encrypted to Livebook Teams servers.\n\nWhen a new synchronization is needed, Livebook Teams sends the encrypted secret to the Livebook of team members, and their Livebook decrypts the secret in their local machines using the same Teams key.","ref":"shared_secrets.html#security-strengths"},{"type":"extras","title":"Shared file storages","doc":"# Shared file storages","ref":"shared_file_storages.html"},{"type":"extras","title":"Overview - Shared file storages","doc":"This feature allows your team to share the configuration of S3-compatible storages.\n\nLivebook file storages are used to store notebooks and their files.\n\nWhenever you add (update or detach) a file storage to your organization hub, Livebook Teams will synchronize that with the Livebook of every member of your organization.\n\n![](images/add_shared_file_storage.png)","ref":"shared_file_storages.html#overview"},{"type":"extras","title":"How it works - Shared file storages","doc":"Here's a video showing how that feature works.","ref":"shared_file_storages.html#how-it-works"},{"type":"extras","title":"Security strengths - Shared file storages","doc":"Livebook Teams cannot access the credentials of your S3 (compatible) account.\n\nLivebook encrypts your S3 credentials locally in your machine using your Teams key. Then, they're sent encrypted to Livebook Teams servers.\n\nWhen a new synchronization is needed, Livebook Teams sends the encrypted credentials to the Livebook of team members, and their Livebook decrypts that in their local machines using the same Teams key.","ref":"shared_file_storages.html#security-strengths"},{"type":"extras","title":"Docker","doc":"# Docker\n\nThere are two main use cases to deploy Livebook in the cloud. The first is to read and write notebooks in the cloud, instead of your machine. The second is to deploy notebooks as applications. This guide covers both as well other details such as clustering.","ref":"docker.html"},{"type":"extras","title":"Livebook in the cloud - Docker","doc":"You can deploy Livebook inside your infrastructure using Docker. The Dockerfile below provides a great starting point:\n\n```dockerfile\nFROM ghcr.io/livebook-dev/livebook\n\n# Configure your port accordingly\nENV LIVEBOOK_PORT 7860\nEXPOSE 7860\n\n# If you have a persistent volume, configure it here\nENV LIVEBOOK_DATA_PATH \"/data\"\nUSER root\nRUN mkdir -p /data\nRUN chmod 777 /data\n```\n\nWe also recommend setting the `LIVEBOOK_PASSWORD` environment variable to a secret value. If it is not set, you will find the token to access Livebook in the logs. See all other supported [environment variables](../../README.md#environment-variables) to learn more.\n\nIf you want to run several Livebook instances behind a load balancer, you need to enable clustering. See the [Clustering](clustering.md) section.\n\nIf you plan to limit access to your Livebook via a proxy, we recommend leaving the \"/public\" route of your instances still public. This route is used for integration with the [Livebook Badge](https://livebook.dev/badge/) and other conveniences.","ref":"docker.html#livebook-in-the-cloud"},{"type":"extras","title":"Docker compose - Docker","doc":"If using Docker Compose the following template is a good starting point:\n\n```yml\nservices:\n  livebook:\n    image: ghcr.io/livebook-dev/livebook\n    ports:\n      - 8090:8090\n      - 8091:8091\n    environment:\n      - LIVEBOOK_PORT=8090\n      - LIVEBOOK_IFRAME_PORT=8091\n```","ref":"docker.html#docker-compose"},{"type":"extras","title":"Deploy notebooks as applications - Docker","doc":"It is possible to deploy any notebook as an application in Livebook. Inside the notebook, open up the Application pane on the sidebar (with a rocket icon), click \"Deploy with Docker\", and follow the required steps. You will be able to choose a Livebook image, preset clustering options, and more.\n\nIf you are using [Livebook Teams](https://livebook.dev/teams/), you will also have access to airgapped notebook deployment with pre-configured Zero Trust Authentication, shared team secrets and file storages. To get started, open up Livebook, click \"Add Organization\" on the sidebar, and visit the \"Airgapped Deployment\" section of your organization.","ref":"docker.html#deploy-notebooks-as-applications"},{"type":"extras","title":"Clustering","doc":"# Clustering\n\nIf you plan to run several Livebook instances behind a load balancer, you need to enable clustering via the `LIVEBOOK_CLUSTER` environment variable. In addition you must set `LIVEBOOK_SECRET_KEY_BASE` and `LIVEBOOK_COOKIE` to different random values (use `openssl rand -base64 48` to generate said values).\n\nDepending on the clustering strategy of your choice, you must set additional environment variables, oftentimes, at runtime. When using the Livebook Docker image, you can create a file at `/app/user/env.sh` that exports the necessary environment variables. This file is invoked right before booting Livebook.\n\nYou may set `LIVEBOOK_CLUSTER` to one of the following values.\n\n## `auto`\n\nDetects the hosting platform and automatically sets up a cluster using DNS configuration. Currently the only supported platform is Fly.io.\n\n## `dns:QUERY`\n\nSets up a cluster using DNS for queries for A/AAAA records to discover new nodes. Additionally, you must additionally set the following env vars:\n\n  * `LIVEBOOK_NODE=livebook_server@MACHINE_IP`, where `MACHINE_IP` is the machine IP of each deployed node\n\n  * If your cloud requires IPv6, also set `ERL_AFLAGS=\"-proto_dist inet6_tcp\"`","ref":"clustering.html"},{"type":"extras","title":"FIPS mode","doc":"# FIPS mode\n\nFor environments that require security hardening, you might need to turn on FIPS ([Federal Information Processing Standards](https://en.wikipedia.org/wiki/Federal_Information_Processing_Standards)) mode. Turning FIPS is a complex procedure, this just enables you to do it.\n\nYou will need to have an Erlang installation that has been compiled with [FIPS enabled](https://www.erlang.org/doc/apps/crypto/fips).","ref":"fips.html"},{"type":"extras","title":"Docker example - FIPS mode","doc":"To do this in Docker, you will need to build it differently. Below is an example Dockerfile with FIPS-enabled Erlang/Elixir base image. You can use it as a base image for building Livebook. See the Livebook Dockerfile for further reference.\n\n```docker\nFROM registry.access.redhat.com/ubi8/ubi-minimal:8.9-1137\n# Set environment variables for path and language\nENV PATH /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin \n\n# Install system dependencies and clean cache in one layer\nRUN microdnf install -y unzip autoconf git ncurses-devel openssl-devel gcc gcc-c++ make automake perl clang wget tar cmake glibc-locale-source glibc-langpack-en && \\\n    microdnf clean all && \\\n    rm -rf /var/cache/yum\n\nWORKDIR /install\n\n# Download, configure, and install Erlang/OTP with FIPS enabled\nARG ERLANG_VERSION\nRUN wget https://github.com/erlang/otp/archive/OTP-${ERLANG_VERSION}.tar.gz && \\\n    tar -xzvf OTP-${ERLANG_VERSION}.tar.gz && \\\n    cd otp-OTP-${ERLANG_VERSION} && \\\n    ./otp_build autoconf && \\\n    ./configure --enable-fips && \\\n    make && make install\n\n# Clone, checkout, and install Elixir\nARG ELIXIR_VERSION\nRUN git clone https://github.com/elixir-lang/elixir.git && \\\n    cd elixir && \\\n    git checkout v${ELIXIR_VERSION} && \\\n    make compile && \\\n    make install\n```","ref":"fips.html#docker-example"},{"type":"extras","title":"Basic Auth","doc":"# Basic Auth\n\nSetting up Basic Authentication is a simple mechanism for protecting all routes of your Livebook instance with a single username-password combo. However, because this password is shared across all users, this authentication mechanism cannot be used to identity users and more robust authentication methods provided by Livebook should be preferred. Basic Authentication occurs in addition to [Livebook's authentication](../authentication.md) for deployed notebooks and admins.","ref":"basic_auth.html"},{"type":"extras","title":"How to - Basic Auth","doc":"To integrate Basic Authentication with Livebook, set the `LIVEBOOK_IDENTITY_PROVIDER` environment variable to `basic_auth: : `.\n\nTo do it, run:\n\n```bash\nLIVEBOOK_IDENTITY_PROVIDER=basic_auth:user:pass \\\nlivebook server\n```","ref":"basic_auth.html#how-to"},{"type":"extras","title":"Livebook Teams - Basic Auth","doc":"[Livebook Teams](https://livebook.dev/teams/) users can deploy notebooks with the click of a button with pre-configured Zero Trust Authentication, shared team secrets, and file storages. Both online and airgapped deployment mechanisms are supported.\n\nFurthermore, if you are deploying multi-session apps via [Livebook Teams](https://livebook.dev/teams/), you can programmatically access data from the authenticated user by calling [`Kino.Workspace.app_info/0`](https://hexdocs.pm/kino/Kino.Workspace.html#app_info/0).\n\nTo get started, open up Livebook, click \"Add Organization\" on the sidebar. Then, inside the notebook of your choice, click \"Deploy with Livebook Teams\".","ref":"basic_auth.html#livebook-teams"},{"type":"extras","title":"Cloudflare","doc":"# Cloudflare\n\nSetting up Cloudflare authentication will protect all routes of your Livebook instance. It is particularly useful for adding authentication to Livebook instances with deployed notebooks. Cloudflare authentication occurs in addition to [Livebook's authentication](../authentication.md) for deployed notebooks and admins.\n\nOnce Cloudflare is enabled, we recommend leaving the \"/public\" route of your instances still public. This route is used for integration with the [Livebook Badge](https://livebook.dev/badge/) and other conveniences.","ref":"cloudflare.html"},{"type":"extras","title":"How to - Cloudflare","doc":"To integrate your Cloudflare Zero Trust authentication with Livebook, set the\n`LIVEBOOK_IDENTITY_PROVIDER` environment variable to `cloudflare: `.\n\nFor more details about how to find your `team-name`, see:\nhttps://developers.cloudflare.com/cloudflare-one/glossary/#team-name.\n\nFor more information about Cloudflare Zero Trust, see:\nhttps://developers.cloudflare.com/cloudflare-one/.","ref":"cloudflare.html#how-to"},{"type":"extras","title":"Livebook Teams - Cloudflare","doc":"[Livebook Teams](https://livebook.dev/teams/) users can deploy notebooks with the click of a button with pre-configured Zero Trust Authentication, shared team secrets, and file storages. Both online and airgapped deployment mechanisms are supported.\n\nFurthermore, if you are deploying multi-session apps via [Livebook Teams](https://livebook.dev/teams/), you can programmatically access data from the authenticated user by calling [`Kino.Workspace.app_info/0`](https://hexdocs.pm/kino/Kino.Workspace.html#app_info/0).\n\nTo get started, open up Livebook, click \"Add Organization\" on the sidebar. Then, inside the notebook of your choice, click \"Deploy with Livebook Teams\".","ref":"cloudflare.html#livebook-teams"},{"type":"extras","title":"Google IAP","doc":"# Google IAP\n\nSetting up Google IAP authentication will protect all routes of your Livebook instance. It is particularly useful for adding authentication to Livebook instances with deployed notebooks. Google IAP authentication occurs in addition to [Livebook's authentication](../authentication.md) for deployed notebooks and admins.\n\nOnce Google IAP is enabled, we recommend leaving the \"/public\" route of your instances still public. This route is used for integration with the [Livebook Badge](https://livebook.dev/badge/) and other conveniences.","ref":"google_iap.html"},{"type":"extras","title":"How to - Google IAP","doc":"To integrate your Google Identity-Aware Proxy (IAP) authentication with Livebook,\nset the `LIVEBOOK_IDENTITY_PROVIDER` environment variable to `google_iap: `.\n\nFor more information about Google IAP, see https://cloud.google.com/iap/docs/concepts-overview.\n\nOnly access with Google accounts is supported. See https://cloud.google.com/iap/docs/authenticate-users-google-accounts.\n\nFor more details about how to find your JWT audience, see https://cloud.google.com/iap/docs/signed-headers-howto and look for \"Signed Header JWT Audience.\"","ref":"google_iap.html#how-to"},{"type":"extras","title":"Livebook Teams - Google IAP","doc":"[Livebook Teams](https://livebook.dev/teams/) users can deploy notebooks with the click of a button with pre-configured Zero Trust Authentication, shared team secrets, and file storages. Both online and airgapped deployment mechanisms are supported.\n\nFurthermore, if you are deploying multi-session apps via [Livebook Teams](https://livebook.dev/teams/), you can programmatically access data from the authenticated user by calling [`Kino.Workspace.app_info/0`](https://hexdocs.pm/kino/Kino.Workspace.html#app_info/0).\n\nTo get started, open up Livebook, click \"Add Organization\" on the sidebar. Then, inside the notebook of your choice, click \"Deploy with Livebook Teams\".","ref":"google_iap.html#livebook-teams"},{"type":"extras","title":"Tailscale","doc":"# Tailscale\n\nSetting up Tailscale authentication will protect all routes of your Livebook instance. It is particularly useful for adding authentication to Livebook instances with deployed notebooks. Tailscale authentication occurs in addition to [Livebook's authentication](../authentication.md) for deployed notebooks and admins.\n\nOnce Tailscale is enabled, we recommend leaving the \"/public\" route of your instances still public. This route is used for integration with the [Livebook Badge](https://livebook.dev/badge/) and other conveniences.","ref":"tailscale.html"},{"type":"extras","title":"How to - Tailscale","doc":"To integrate Tailscale authentication with Livebook,\nset the `LIVEBOOK_IDENTITY_PROVIDER` environment variable to `tailscale:tailscale-socket-path`, make sure the `tailscale` CLI is installed and available on your machine (or your Docker image).\n\nIf you want to access Livebook on the same machine as you are hosting it,\nyou must also set the `LIVEBOOK_IP` variable to your Tailscale IP.\n\nTo do both of these things, run:\n\n```bash\nLIVEBOOK_IP=$(tailscale ip -1 | tr -d '\\n') \\\nLIVEBOOK_IDENTITY_PROVIDER=tailscale:/var/run/tailscale/tailscaled.sock \\\nlivebook server\n```\n\nSee https://tailscale.com/blog/tailscale-auth-nginx/ for more information\non how Tailscale authentication works.","ref":"tailscale.html#how-to"},{"type":"extras","title":"macOS - Tailscale","doc":"On macOS, when Tailscale is installed via the Mac App Store, no unix socket is exposed.\nInstead, a TCP port is made available and protected via a password, which needs to be located.\nTailscale itself uses lsof for this. This method is replicated in the bash script below,\nwhich will start Livebook with your Tailscale IP and correct port and password.\n\n```bash\n#!/bin/bash\naddr_info=$(lsof -n -a -c IPNExtension -F | sed -n 's/.*sameuserproof-\\([[:digit:]]*-.*\\).*/\\1/p')\nport=$(echo \"$addr_info\" | cut -d '-' -f 1)\npass=$(echo \"$addr_info\" | cut -d '-' -f 2)\nLIVEBOOK_IP=$(exec $(ps -xo comm | grep MacOS/Tailscale$) ip | head -1 | tr -d '\\n') \\\nLIVEBOOK_IDENTITY_PROVIDER=tailscale:http://:$pass@127.0.0.1:$port \\\nlivebook server\n```","ref":"tailscale.html#macos"},{"type":"extras","title":"Livebook Teams - Tailscale","doc":"[Livebook Teams](https://livebook.dev/teams/) users can deploy notebooks with the click of a button with pre-configured Zero Trust Authentication, shared team secrets, and file storages. Both online and airgapped deployment mechanisms are supported.\n\nFurthermore, if you are deploying multi-session apps via [Livebook Teams](https://livebook.dev/teams/), you can programmatically access data from the authenticated user by calling [`Kino.Workspace.app_info/0`](https://hexdocs.pm/kino/Kino.Workspace.html#app_info/0).\n\nTo get started, open up Livebook, click \"Add Organization\" on the sidebar. Then, inside the notebook of your choice, click \"Deploy with Livebook Teams\".","ref":"tailscale.html#livebook-teams"},{"type":"extras","title":"Custom","doc":"# Custom\n\nIt is possible to provide custom Zero Trust Authentication (ZTA) inside Livebook's Docker images.\n\nTo do so, you must define a file with the `.exs` extension inside the `/app/user/extensions` of your Livebook image, for example, `/app/user/extensions/my_auth.exs`. This file should define at least one module, which implements the ZTA skeleton below:\n\n```elixir\ndefmodule MyAuth do\n  use GenServer\n\n  @spec start_link(keyword) :: {:ok, pid()}\n  def start_link(opts) do\n    identity_key = opts[:identity_key]\n    GenServer.start_link(__MODULE__, identity_key, Keyword.take(opts, [:name]))\n  end\n\n  @spec authenticate(GenServer.server(), Plug.Conn.t(), keyword()) ::\n          {Plug.Conn.t(), map() | nil}\n  def authenticate(server, conn, opts \\\\ []) do\n    # Connects to the GenServer given by `server` and returns the user information.\n    # See `opts[:fields]` for the fields to be returned in the map.\n    # Return nil if the user cannot be authenticated.\n  end\nend\n```\n\nThen you must configure Livebook to use the module above as your identity provider:\n\n```bash\nLIVEBOOK_IDENTITY_PROVIDER=\"custom:MyAuth\"\n```\n\nOr, if you want to pass a custom identity key:\n\n```bash\nLIVEBOOK_IDENTITY_PROVIDER=\"custom:MyAuth:my-key\"\n```\n\nKeep in mind that the identity provider contract in Livebook is still evolving and it may change in future releases. Additionally, your code may rely on two dependencies: [Req ~> 0.4](https://hexdocs.pm/req) and [JOSE ~> 1.11](https://hexdocs.pm/jose).","ref":"custom_auth.html"},{"type":"extras","title":"Development - Custom","doc":"If you want to try your custom identity provider in development, you can [clone Livebook's git repository](https://github.com/livebook-dev/livebook) and then execute the following command inside Livebook's root folder:\n\n```elixir\n$ mix setup\n$ LIVEBOOK_IDENTITY_PROVIDER=\"custom:MyAuth\" elixir -r path/to/my_auth.exs -S mix phx.server\n```","ref":"custom_auth.html#development"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}